import com.wonxing.humanseg.*;

import java.io.*;
import java.util.Base64;

public class MattingDemo {
    public static void main(String[] args) {
        int gpuEnabled = 0;
        WXHumanMatting matting;
        try {
            // 如果是Android版SDK
            // 则使用WXSDKAndroid.initWithLicensePath()初始化
            WXHumanSegSDK.initWithLicensePath("你的appkey", "./my.lic");
            String version = WXHumanSegSDK.version();
            System.out.println("WXHumanSegSDK version:" + version);
            matting = new WXHumanMatting(gpuEnabled);
        } catch (WXException e) {
            System.out.println("WXException code " + e.errCode() + ", " + e.errMsg());
            return;
        }

        String inputPath = "test1.jpg";
        if (args.length >= 1) {
            inputPath = args[0];
        }
        int loop = 1;
        if (args.length >= 2) {
            try {
                loop = Integer.parseInt(args[1]);
            } catch(Exception e) {
            }
            if (loop < 1) {
                loop = 1;
            }
        }

        for (int i = 1; i <= loop; i ++) {
            test(matting, inputPath);
            System.out.println("*************** test " + i + " times *************");
        }

        matting.release();
        WXHumanSegSDK.terminate();
    }

    public static void test(WXHumanMatting matting, String inputImagePath) {
        try {

            WXImage inputImage = WXImage.fromFile(inputImagePath);
            WXImage bgImage = WXImage.fromColor(inputImage.width(), inputImage.height(), 255, 0, 0);
            WXImage resImg = matting.removeBackground(inputImage, bgImage);

            resImg.save("./save_to_file.jpg");

            // 如果不使用以下release函数，
            // 对象也将会被java的oom回收，不会造成内存泄露，
            // 调用了release函数，可以主动释放C++层的内存，
            // 可以优化内存使用效率，
            // 但一旦release函数被调用，此对象就不能再次被使用
            bgImage.release();
            inputImage.release();
            resImg.release();
        } catch (WXException e) {
            System.out.println("WXException code " + e.errCode() + ", " + e.errMsg());
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
